; $B%a%C%;!<%8$O0J2<$NJQ?t$NCM$K$h$C$F7h$a$i$l$k!#(B
; $B2K$J?M$,8=$l$F$b$C$HE,@Z$J%a%C%;!<%8BN7O$r9=C[$7$F$/$l$k$3$H$rK>$`!#(B
;
; TRR:beginner-flag         $B=i$a$F(Btrr$B$r$7$?$+$I$&$+(B
; TRR:random-flag           $B%F%-%9%H$,%i%s%@%`$+$I$&$+(B
; TRR:update-flag           $B5-O?99?7$7$?$+$I$&$+(B
; TRR:pass-flag             $B%9%F%C%W$r%Q%9$7$?$+$I$&$+(B
; TRR:secret-flag           $BHkL)<g5A<T$+$I$&$+(B
; TRR:cheat-flag            $B2?$i$+$N5?$o$7$-9T0Y$r$7$?$+$I$&$+(B
; TRR:typist-flag           $B%?%$%T%9%H$rL\;X$9$+$I$&$+(B
; TRR:steps                 $B8=:_$N%9%F%C%W(B
; TRR:eval                  $B:#2s=P$7$?E@?t(B
; TRR:whole-char-count      $B%F%-%9%H$NJ8;z?t(B
; TRR:high-score-old        $BA02s$^$G$N:G9bF@E@(B
; TRR:high-score            $B:#2s$^$G$N:G9bF@E@(B
; TRR:miss-type-ratio       $B%_%9N((B ($B@iJ,N((B)
; TRR:type-speed            $B%?%$%T%s%0B.EY!JJ8;z?t!?J,!K(B
; TRR:total-times           $B:#$^$G$NN_@Q<B9T2s?t(B
; TRR:total-time            $B:#$^$G$NN_@Q<B9T;~4V(B
; TRR:times-for-message            $B$3$N%9%F%C%W$G$NN_@Q<B9T2s?t(B


(defun TRR:print-first-message-as-result ()
  (insert  " $B$h$&$3$=(Btrr$B$N@$3&$X!*(B\n\
 $BCk5Y$_$d;E;v$N8e$K!"(B\n\
 $B0?$$$O;E;v$N:GCf$K$b(B\n\
 $B4hD%$C$F(Btrr$B$KNe$b$&!*(B"))


(defun TRR:print-message ()
  (let ((fill-column (- (window-width) 3)))
    (delete-region (point-min) (point-max))
    (insert "  ")
    (TRR:print-message-main)
    (fill-region (point-min) (point-max))
    (beginning-of-buffer)))


(defun TRR:print-message-main ()
  (let ((diff (- (* (1+ TRR:steps) 10) TRR:eval)))
    (cond
     (TRR:cheat-flag                                   ; $B$$$s$A$-$7$F$$$k?M$X(B
      (TRR:message-for-cheater))
     (TRR:secret-flag
      (TRR:message-for-secret-player))
     (TRR:typist-flag
      (TRR:message-for-typist))
     (TRR:beginner-flag                                ; $B=i$a$F(Btrr$B$r$7$??M$X(B
      (TRR:message-for-beginner))
     ((and TRR:update-flag TRR:pass-flag)
      (insert
       (format "$B%9%F%C%W(B%d$BFMGK$=$7$F5-O?99?7$*$a$G$H$&!#(B" TRR:steps))
      (if (< (% TRR:high-score 100) (% TRR:high-score-old 100))
	  (progn                                       ; $BBgBf$rFMGK$7$??M$X(B
	    (TRR:message-specially-for-record-breaker))
	(TRR:message-for-record-breaker))              ; $B5-O?99?7$7$??M$X(B
      (setq TRR:high-score-old TRR:high-score))
     (TRR:update-flag                                  ; $B5-O?99?7$7$??M$X(B
      (insert "$B5-O?99?7$*$a$G$H$&!*(B")
      (TRR:message-for-record-breaker)                 ; $B5-O?99?7$7$??M$X(B
      (setq TRR:high-score-old TRR:high-score))
     (TRR:pass-flag                                    ; $B%9%F%C%W$rFMGK$7$??M$X(B
      (insert
       (format "$B%9%F%C%W(B%d$BFMGK$*$a$G$H$&!#(B" TRR:steps))
      (TRR:message-for-success))
     ((= TRR:eval 0)
      (insert "$B#0E@$J$s$FCQ$:$+$7$$$o!#$b$C$HEXNO$7$J$5$$!#(B"))
     ((< diff  60)
      (TRR:message-for-failed-one-1 diff))
     ((or (< diff 100) (> TRR:miss-type-ratio 30))
      (TRR:message-for-failed-one-2 diff))
     (t
      (TRR:message-for-failed-one-3 diff)))))


(defun TRR:message-for-cheater ()
  (cond 
   ((> TRR:eval 750)
    (insert "$B$=$s$J$3$H$G$$$$$N!)CQ$rCN$j$J$5$$!#(B"))
   ((< TRR:whole-char-count 160)
    (insert "$BH\61$h!#%F%-%9%H$,>/$J2a$.$k$o!#(B"))
   ((and (< TRR:whole-char-count 480) TRR:typist-flag)
    (insert "$BH\61$h!#%F%-%9%H$,>/$J2a$.$k$o!#(B"))
   ((> (- TRR:eval TRR:high-score-old) 100)
    (insert
     (format "$B$3$l$^$G(B%d$BE@$7$+<h$l$J$+$C$??M$,5^$K(B%d$BE@$r<h$k$J$s$F2?$+$$$s$A$-$d$C$F$k$G$7$g$&!)(B"
	     TRR:high-score-old TRR:eval)))))


(defun TRR:message-for-secret-player ()
  (cond
   (TRR:pass-flag
    (setq TRR:secret-flag nil)
    (setq TRR:update-flag nil)
    (setq TRR:beginner-flag nil)
    (TRR:print-message-main)
    (setq TRR:secret-flag t))
   ((> TRR:eval 300)
    (insert "$B$3$s$J9b$$F@E@$r=P$9J}$,$I$&$7$FHkL)$K$7$F$*$/$N!)(B"))
   ((> TRR:eval 200)
    (insert "$B6H3&I8=`$r1[$($F$k$o!#HkL)$K$9$kI,MW$OA4$/$J$$$o$h!#(B"))
   ((> TRR:eval 120)
    (insert "$BCQ$:$+$7$/$J$$E@$@$o!#HkL)$K$9$k$N$O$b$&$d$a$^$7$g$&!#(B"))
   (t
    (insert "$B8x3+$9$k$H$A$g$C$HCQ$:$+$7$$E@$@$o!#$7$P$i$/HkL)$GB3$1$^$7$g$&!#(B"))))


(defun TRR:message-for-beginner ()
  (cond
   ((= TRR:eval 0)
    (insert "$B#0E@$H$$$&$N$OLdBj$@$o!#$3$l$+$i$+$J$j$NEXNO$,I,MW$h!#F;$N$j$OD9$$$1$I4hD%$j$^$7$g$&!#(B"))
   ((< TRR:eval 40)
    (insert "$B>/$J$/$H$b1QJ8;z$0$i$$$O@dBP3P$($k$3$H!#6H3&I,?\$N(B100$BE@$K8~$1$F$3$l$+$i4hD%$j$^$7$g$&!#(B"))
   ((< TRR:eval 80)
    (insert "$B%-!<G[CV$bBgJ,3P$($?$h$&$@$1$I$^$@$^$@$@$o!#6H3&I,?\$N(B100$BE@$K8~$1$F$3$l$+$i4hD%$j$^$7$g$&!#(B"))
   ((< TRR:eval 130)
    (insert "$B4pACE*$J5;=Q$O?H$KIU$1$F$$$k$h$&$@$1$I$^$@$^$@$@$o!#6H3&I8=`$N(B200$BE@$K8~$1$F$3$l$+$i4hD%$j$^$7$g$&!#(B"))
   ((< TRR:eval 180)
    (insert "$B$J$+$J$+$N<BNO$M!#$G$b%9%T!<%I$H@53N$5$,>/$7B-$j$J$$$o!#6H3&I8=`$N(B200$BE@$K8~$1$F$b$&>/$74hD%$j$^$7$g$&!#(B"))
   ((< TRR:eval 280)
    (insert "$B$J$+$J$+$d$k$o$M!#$b$&>/$74hD%$l$P6H3&L\I8$N(B300$BE@$r$-$C$HFMGK$G$-$k$o!#(B"))
   ((< TRR:eval 380)
    (insert "$B$9$4$$$o$M!#=i$a$F$G$3$l$0$i$$=P$;$l$P==J,$@$o!#$G$b6H3&0lN.$N(B400$BE@$K8~$1$F$b$&>/$74hD%$j$^$7$g$&!#(B"))
   ((< TRR:eval 480)
    (insert "$B$9$C$4$$!*$3$s$JE@$r=P$9?M$OLGB?$K$$$J$$$o$h!#$R$g$C$H$7$F%W%m$G$O$J$$$+$7$i!)(B"))
   (t
    (insert "$B$"$^$j$K$bD6?ME*$@$o!#$-$C$H%.%M%9%V%C%/$K:\$k$o$h!#(B"))))


(defun TRR:message-for-success ()
  (cond
   ((>= (- TRR:eval (* 10 (1+ TRR:steps))) 100)
    (insert "$B$"$J$?$K$O4JC12a$.$?$h$&$M!#(B"))
   ((<= TRR:times-for-message 2)
    (insert "$B7Z$/FMGK$7$?$o$M!#(B"))
   ((<= TRR:times-for-message 4)
    (insert "$B$o$j$H4JC1$KFMGK$7$?$o$M!#(B"))
   ((<= TRR:times-for-message 8)
    (insert "$B$A$g$C$H$F$3$:$C$?$h$&$M!#(B"))
   ((<= TRR:times-for-message 16)
    (insert "$B$@$$$V$F$3$:$C$?$h$&$M!#(B"))
   ((<= TRR:times-for-message 32)
    (insert "$B$h$/4hD%$C$?$o$M!#(B"))
   ((<= TRR:times-for-message 64)
    (insert "$B?oJ,6lO+$7$?$h$&$M!#(B"))
   ((<= TRR:times-for-message 128)
    (insert "$B6l$7$_$L$$$?$o$M!#(B"))
   (t
    (insert 
     (format "%d$B2s$bD)@o$9$k$J$s$F$9$4$$$o!#<9G0$G$d$j$H$2$?$o$M!#(B" TRR:times-for-message)))))


(defun TRR:message-for-failed-one-1 (diff)
  (cond 
   ((< diff 10)
    (insert "$B$"$H$[$s$N>/$7$@$C$?$N$K(B....$BK\Ev$K@K$7$+$C$?$o$M!#(B"))
   ((< diff 20)
    (insert "$B@K$7$+$C$?$o$M!#(B"))
   ((< diff 30)
    (insert "$B$=$ND4;R$h!#(B"))
   ((< diff 40)
    (insert "$B$b$&0lB)$@$o!#$G$bB)H4$-$O$@$a$h!#(B"))
   ((< diff 50)
    (insert "$B4hD%$l$P$-$C$H$G$-$k$o!#(B"))
   (t
    (insert "$BEXNO$"$k$N$_$h!#(B"))))


(defun TRR:message-for-failed-one-2 (diff)
  (cond 
   ((> TRR:miss-type-ratio 60)
    (insert "$B%_%9$,$"$^$j$K$bB?2a$.$k$+$i%@%a$J$N$h!#$H$K$+$/@53N$KBG$DN}=,$KNe$_$J$5$$!#$b$&$=$l$7$+J}K!$O$J$$$o!#(B"))
   ((> TRR:miss-type-ratio 40)
    (insert "$B%_%9$,B?2a$.$k$o!#=i?4$K5"$C$F0l$D0l$D?5=E$KBG$DN}=,$r$7$J$5$$!#(B"))
   ((> TRR:miss-type-ratio 24)
    (insert "$B%_%9$,B?$$$o!#@53N$KBG$DN}=,$r$7$J$5$$!#(B"))
   ((> TRR:miss-type-ratio  8)
    (insert "$BN}=,$KN}=,$r=E$M$J$5$$!#(B"))
   (t
    (insert "$B@53N$KBG$C$F$k$h$&$@$1$I%9%T!<%I$,CY$9$.$k$o!#B.$/BG$DN}=,$KNe$_$J$5$$!#(B"))))


(defun TRR:message-for-failed-one-3 (diff)
  (cond 
   ((< diff 110)
    (insert "$B!V(Btrr$B$NF;$O0lF|$K$7$F$J$i$:!W(B"))
   ((< diff 120)
    (insert "$B!V(Btrr$B$K2&F;$J$7!W(B"))
   ((< diff 130)
    (insert
     (format "$B$"$i$^$!!#(B%d$BE@$r=P$7$??M$,$?$C$?$N(B%d$BE@$J$s$F$$$C$?$$$I$&$7$?$N$h!#(B"
	     TRR:high-score TRR:eval)))
   ((< diff 140)
    (insert
     (format "%d$BE@$O$^$0$l$@$C$?$N!)(B" TRR:high-score)))
   (t
    (insert "$B$"$J$?$N<BNO$C$F$3$NDxEY$@$C$?$N$M!#(B"))))


(defun TRR:message-specially-for-record-breaker ()
  (cond 
   ((< TRR:high-score-old 100)
    (insert "$B$D$$$K6H3&I,?\$N(B100$BE@FMGK$M!*$3$l$+$i$O6H3&I8=`$N(B200$BE@$rL\;X$7$F4hD%$j$^$7$g$&!#(B"))
   ((< TRR:high-score-old 200)
    (insert "$B$D$$$K6H3&I8=`$N(B200$BE@FMGK$M!*$3$l$+$i$O6H3&L\I8$N(B300$BE@$rL\;X$7$F4hD%$j$^$7$g$&!#(B"))
   ((< TRR:high-score-old 300)
    (insert "$B$D$$$K6H3&L\I8$N(B300$BE@FMGK$M!*$3$l$+$i$O6H3&0lN.$N(B400$BE@$rL\;X$7$F4hD%$j$^$7$g$&!#(B"))
   ((< TRR:high-score-old 400)
    (insert "$B$D$$$K6H3&0lN.$N(B400$BE@FMGK$M!*$3$l$+$i$O6H3&D60lN.$N(B500$BE@$rL\;X$7$F4hD%$j$^$7$g$&!#(B"))
   ((< TRR:high-score-old 500)
    (insert "$B$D$$$K6H3&D60lN.$N(B500$BE@FMGK$M!*$3$l$+$i$O6H3&D:E@$N(B600$BE@$rL\;X$7$F4hD%$j$^$7$g$&!#(B"))
   (t
    (insert "$B$"$J$?$N$h$&$J$9$4$$?M$O=i$a$F$h!#%W%m$K$J$l$k$o!#(B"))))


(defun TRR:message-for-record-breaker ()
  (cond
   ((< TRR:high-score  67)
    (insert "$B6H3&I,?\$N(B100$BE@;X$7$F4hD%$C$F!#(B"))
   ((< TRR:high-score 100)
    (insert "$B6H3&I,?\$N(B100$BE@$^$G$b$&$9$0$h!#(B"))
   ((< TRR:high-score 167)
    (insert "$B6H3&I8=`$N(B200$BE@L\;X$7$F4hD%$C$F!#(B"))
   ((< TRR:high-score 200)
    (insert "$B6H3&I8=`$N(B200$BE@$^$G$b$&$9$0$h!#(B"))
   ((< TRR:high-score 267)
    (insert "$B6H3&L\I8$N(B300$BE@L\;X$7$F4hD%$C$F!#(B"))
   ((< TRR:high-score 300)
    (insert "$B6H3&L\I8$N(B300$BE@$^$G$b$&$9$0$h!#(B"))
   ((< TRR:high-score 367)
    (insert "$B6H3&0lN.$N(B400$BE@L\;X$7$F4hD%$C$F!#(B"))
   ((< TRR:high-score 400)
    (insert "$B6H3&0lN.$N(B400$BE@$^$G$b$&$9$0$h!#(B"))
   ((< TRR:high-score 467)
    (insert "$B6H3&D60lN.$N(B500$BE@L\;X$7$F4hD%$C$F!#(B"))
   ((< TRR:high-score 500)
    (insert "$B6H3&D60lN.$N(B500$BE@$^$G$b$&$9$0$h!#(B"))
   ((< TRR:high-score 567)
    (insert "$B6H3&D:E@$N(B600$BE@$^$GL\;X$7$F4hD%$C$F!#(B"))
   ((< TRR:high-score 600)
    (insert "$B6H3&D:E@$N(B600$BE@$^$G$b$&$9$0$h!#(B"))
   (t
    (insert "$B$h$/$3$3$^$G$d$k$o$M!#$"$J$?$NL\I8$O0lBN2?$J$N!)(B"))))


(defun TRR:message-for-typist ()
  (cond
   (TRR:beginner-flag
    (insert "$B%?%$%T%9%H$X$NF;$O81$7$$$o$h!#>/$J$/$H(B300$BE@$r%3%s%9%?%s%H$K=P$9$h$&$K4hD%$C$F!#(B")
    (setq TRR:beginner-flag nil))
   ((and TRR:pass-flag (not TRR:update-flag))
    (setq TRR:typist-flag nil)
    (TRR:print-message-main)
    (setq TRR:typist-flag t))
   ((and TRR:update-flag TRR:pass-flag)
    (insert "$B5-O?99?7$=$7$F(B")
    (setq TRR:typist-flag nil)
    (setq TRR:update-flag nil)
    (TRR:print-message-main)
    (setq TRR:typist-flag t))
   (TRR:update-flag (insert "$B5-O?99?7$*$a$G$H$&!*(B"))
   ((> TRR:miss-type-ratio 30)
    (insert "$B$"$J$?$K$OL5M}$h!#%?%$%T%9%H$K$J$m$&$J$s$FEvJ,9M$($J$$$3$H$M!#(B"))
   ((> TRR:miss-type-ratio 20)
    (insert "$B#0E@$J$s$FCQ$:$+$7$$$o$M!#$3$N6~?+$r6;$K?<$/9o$_9~$_$J$5$$!#(B"))
   ((> TRR:miss-type-ratio 15)
    (insert "$B%_%9$,$"$^$j$K$bB?2a$.$k$o!#@P66$rC!$$$FEO$k$h$&$K%?%$%W$7$J$5$$!#(B"))
   ((> TRR:miss-type-ratio 10)
    (insert "$B%_%9$,B?2a$.$k$o!#$b$C$H?5=E$K%?%$%W$7$J$5$$!#(B"))
   ((> TRR:miss-type-ratio 6)
    (insert "$B%_%9$,B?$$$o!#$b$C$H?5=E$K%?%$%W$7$?J}$,$$$$$o$h!#(B"))
   (t
    (setq TRR:typist-flag nil)
    (TRR:print-message-main)
    (setq TRR:typist-flag t))))

